package br.com.webpublico.<%=modulo%>.controllers;

import br.com.webpublico.comum.controllers.CRUD;
import br.com.webpublico.<%=modulo%>.entities.<%=classe%>;
import br.com.webpublico.<%=modulo%>.services.<%=classe%>Service;
import br.com.webpublico.comum.services.AbstractService;
import br.com.webpublico.comum.controllers.AbstractController;

import com.ocpsoft.pretty.faces.annotation.URLAction;
import com.ocpsoft.pretty.faces.annotation.URLMapping;
import com.ocpsoft.pretty.faces.annotation.URLMappings;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import java.io.Serializable;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@ManagedBean
@ViewScoped
@URLMappings(mappings = {
    @URLMapping(id = "nov<%=finalGenero%><%=classe%>", pattern = "/<%=url%>/novo/", viewId = "/faces/<%=modulo%>/<%=url%>/edita.xhtml"),
    @URLMapping(id = "editar<%=classe%>", pattern = "/<%=url%>/editar/#{<%=variavel%>Controller.id}/", viewId = "/faces/<%=modulo%>/<%=url%>/edita.xhtml"),
    @URLMapping(id = "listar<%=classe%>", pattern = "/<%=url%>/listar/", viewId = "/faces/<%=modulo%>/<%=url%>/lista.xhtml"),
    @URLMapping(id = "ver<%=classe%>", pattern = "/<%=url%>/ver/#{<%=variavel%>Controller.id}/", viewId = "/faces/<%=modulo%>/<%=url%>/visualizar.xhtml")
})
@Component
public class <%=classe%>Controller extends AbstractController<<%=classe%>> implements Serializable, CRUD {

    private static final Logger logger = LoggerFactory.getLogger(<%=classe%>Controller.class);

    @Autowired
    private <%=classe%>Service <%=variavel%>Service;

    public <%=classe%>Controller() {
        super(<%=classe%>.class);
    }

    @Override
    public AbstractService getService() {
        return <%=variavel%>Service;
    }

    @URLAction(mappingId = "nov<%=finalGenero%><%=classe%>", phaseId = URLAction.PhaseId.RENDER_RESPONSE, onPostback = false)
    @Override
    public void novo() {
        super.novo();
    }

    @URLAction(mappingId = "ver<%=classe%>", phaseId = URLAction.PhaseId.RENDER_RESPONSE, onPostback = false)
    @Override
    public void ver() {
        super.ver();
    }

    @URLAction(mappingId = "editar<%=classe%>", phaseId = URLAction.PhaseId.RENDER_RESPONSE, onPostback = false)
    @Override
    public void editar() {
        super.editar();
    }

    @Override
    public String getCaminhoPadrao() {
        return "/<%=url%>/";
    }

    @Override
    public Object getUrlKeyValue() {
        return selecionado.getId();
    }

    @Override
    protected String getMensagemSucessoAoSalvar() {
        return "<%=finalGenero.toUpperCase()%> <%=variavel%> " + selecionado.getId() + " foi salv<%=finalGenero%> com sucesso.";
    }

    @Override
    protected String getMensagemSucessoAoExcluir() {
        return "<%=finalGenero.toUpperCase()%> <%=variavel%> " + selecionado.getId() + " foi excluíd<%=finalGenero%> com sucesso.";
    }

    public List<<%=classe%>> <%=variavelPlural%>() {
        return <%=variavel%>Service.buscarTodos();
    }
}
