package br.com.webpublico.<%=modulo%>.repositories.jdbc;

import br.com.webpublico.<%=modulo%>.entities.<%=classe%>;
import br.com.webpublico.comum.repositories.jdbc.WebPublico<%=temChaveNegocio ? 'ChaveNegocio' : ''%>JDBCRepository;
import br.com.webpublico.<%=modulo%>.repositories.jdbc.statements.Statements<%=classe%>;
import br.com.webpublico.comum.annotations.RepositorioJDBC;
import org.springframework.beans.factory.annotation.Autowired;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import static br.com.webpublico.comum.utils.UtilEntidades.traduzirEnum;

@RepositorioJDBC
public class <%=classe%>JDBCRepository extends WebPublico<%=temChaveNegocio ? 'ChaveNegocio' : ''%>JDBCRepository<<%=classe%>> {

    @Autowired
    public <%=classe%>JDBCRepository(Connection conn) {
        super(conn);
    }

    @Override
    protected void validarRegistro(<%=classe%> registro) {

    }

    @Override
    protected PreparedStatement recuperarPreparedStatementInsert() {
        return getPreparedStatement(Statements<%=classe%>.INSERT);
    }

    @Override
    protected PreparedStatement recuperarPreparedStatementPreCarga() {
        return getPreparedStatement(Statements<%=classe%>.SELECT_ALL);
    }

    @Override
    protected <%=classe%> preencherRegistro(ResultSet rs) throws SQLException {
        <%=classe%> retorno = new <%=classe%>();
        retorno.setId(getLong(rs, "id"));<%for(fieldId in fields){%>
        retorno.set<%=fields[fieldId].capitalizedFieldName%>(get<%=fields[fieldId].fieldType.type == 'Integer' ? 'Int' : fields[fieldId].fieldType.type%>(rs, "<%=fields[fieldId].fieldName%>"));<%}%>
        return retorno;
    }

    @Override
    protected void preencherCamposInsert(<%=classe%> registro, PreparedStatement ps) throws SQLException {
        registro.setId(nextIDFactory.nextID());
        setLongObrigatorio(ps, 1, registro.getId());<%for(fieldId in fields){%>
        set<%=fields[fieldId].fieldType.type == 'Integer' ? 'Int' : fields[fieldId].fieldType.type%><%=fields[fieldId].annotations.obrigatorio ? 'Obrigatorio' : 'Opcional'%>(ps, <%=(fieldId*1 + 2)%>, registro.get<%=fields[fieldId].capitalizedFieldName%>());<%}%>
    }
}