package br.com.webpublico.<%=modulo%>.repositories.jpa;

import br.com.webpublico.comum.repositories.jpa.AbstractJPARepositoryTest;
import br.com.webpublico.<%=modulo%>.entities.<%=classe%>;
import br.com.webpublico.comum.entities.EntidadeWebPublico;
import br.com.webpublico.<%=modulo%>.repositories.jpa.<%=classe%>JPARepository;
import org.hibernate.envers.AuditReaderFactory;
import org.junit.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;

import javax.persistence.Query;
import java.util.Collections;
import java.util.List;

import static org.hamcrest.CoreMatchers.equalTo;
import static org.hamcrest.CoreMatchers.is;
import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.empty;
import static org.mockito.Matchers.anyString;
import static org.mockito.Mockito.*;

import static br.com.webpublico.comum.utils.TestUtil.randomValue;

public class <%=classe%>JPARepositoryTest extends AbstractJPARepositoryTest<<%=classe%>JPARepository%>> {

    @InjectMocks
    private <%=classe%>JPARepository sut;

    @Mock
    private AuditReaderFactory auditReaderFactory;

    @Override
    protected <%=classe%>JPARepository getSut() {
        return sut;
    }

    @Override
    protected EntidadeWebPublico getEntidadeValida() {
        <%=classe%> retorno = new <%=classe%>();<%for(fieldId in fields) { if(fields[fieldId].annotations.obrigatorio) {%>
        retorno.set<%=fields[fieldId].capitalizedFieldName%>((<%=fields[fieldId].fieldType.type%>)randomValue(<%=fields[fieldId].fieldType.type%>.class, <%=fields[fieldId].fieldType.size ? fields[fieldId].fieldType.size : 'null'%>));<%}}%>
        return retorno;
    }

}
